package com.fp.persistence.pgeneral.product;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEPRODUCTRELATIONSHIP*/
@Embeddable
public class TgeneProductRelationshipKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="MODULECODE", nullable=false,updatable=false)

/**
* Codigo de modulo
*/
private String modulecode;

@Column(name="RELATIONSHIPCODE", nullable=false,updatable=false)

/**
* Codigo de relacion de la cuenta con el cliente
*/
private String relationshipcode;

/**Contructor por defecto*/
public TgeneProductRelationshipKey(){}
/**Contructor de TgeneProductRelationshipKey
@param pModulecode Codigo de modulo
@param pRelationshipcode Codigo de relacion de la cuenta con el cliente
*/
public TgeneProductRelationshipKey(String pModulecode,String pRelationshipcode){
 modulecode=pModulecode;
 relationshipcode=pRelationshipcode;
}
/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de relationshipcode
@return valor de relationshipcode*/
public String getRelationshipcode(){
  return relationshipcode;
}
/**Fija el valor de relationshipcode
@param pRelationshipcode nuevo Valor de relationshipcode*/
public void setRelationshipcode(String pRelationshipcode){
  relationshipcode=pRelationshipcode;
}

/**Implementación de la comparación de TgeneProductRelationshipKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneProductRelationshipKey))return false;
  TgeneProductRelationshipKey that = (TgeneProductRelationshipKey) o;
  if (this.getModulecode() == null || that.getModulecode() == null){
      return false;
  }
  if (! this.getModulecode().equals(that.getModulecode())){
    return false;
  }
  if (this.getRelationshipcode() == null || that.getRelationshipcode() == null){
      return false;
  }
  if (! this.getRelationshipcode().equals(that.getRelationshipcode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneProductRelationshipKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getModulecode() == null ? 0 : this.getModulecode().hashCode());
    result = result * 37 + (this.getRelationshipcode() == null ? 0 : this.getRelationshipcode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
